<?php

namespace App\Http\Controllers\API\v1;

use App\Http\Controllers\Controller;
use App\Models\EmployeeOffset;
use App\Models\OffsetRemaining;
use App\Models\User;
use App\Notifications\OffsetAvailment;
use Exception;
use Illuminate\Http\Request;
use Illuminate\Http\Response;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Validator;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Notification;
use Illuminate\Support\Facades\Storage;
use Illuminate\Validation\Rule;
use PHPUnit\Event\Code\Throwable;
use Illuminate\Support\Str;

class EmployeeOffsetController extends Controller
{
    public function index(Request $request)
    {
        //
        $employee = Auth::user();

        $keyword = $request->input('keyword', '');
        $perPage = $request->input('per_page',PHP_INT_MAX);
        $sortBy = $request->input('sortBy', '');
        $sortType = $request->input('sortType', '');
        $data = EmployeeOffset::with([
            'recommending' => fn($recommending) => $recommending->select('employee_id', 'asa_user_id', 'firstname', 'lastname'),
            'approving'=> fn($approving) => $approving->select('employee_id', 'asa_user_id', 'firstname', 'lastname'),
            ])
            ->select(
                'id', 
                'employee_id', 
                'company_id', 
                'dealer_id', 
                'date_from',
                'date_to',
                'from_time',
                'to_time',
                'days',
                'hours',
                'attachment', 
                'description', 
                'denied_reason', 
                'status', 
                'recommending_id', 
                'allow_higher_approval', 
                'approver_id', 
                'recommended_at', 
                'approved_at',
                'created_at',
                'posted'
            )
            ->where(function ($query) use ($keyword) {
            $keyword = str_replace(" ", "%", $keyword);
            // $query->where('name', 'like', '%' . $keyword . '%');
        });

        $availableOffset = '';
        $usedOffset = '';

        if($employee->roles[0]['group_id'] != 1){
            $data->where(['employee_id' => $employee->employee_id]);

            $availableOffset = OffsetRemaining::where('employee_id', '=', $employee->employee_id)
            ->pluck('remaining');

            $usedOffset = EmployeeOffset::select(DB::raw('SUM(hours) as totalOffset'))
                ->where('employee_id', '=', $employee->employee_id)
                ->where('status', '!=', '99')
                ->where('enabled', '=', '1')
                ->first();
        }

        if (!empty($sortBy) && !empty($sortType)) {
            $data = $data->orderBy($sortBy, $sortType);
        }

        $data = $data->paginate($perPage);

        $response = [
            'data' => $data,
            'available_offset' => $availableOffset,
            'offset_used' => $usedOffset
        ];

        // dd($response);

        return response()->json($response);
    }

    public function getOffsetAvailmentList(Request $request)
    {
        //
        $employee = Auth::user();

        $keyword = $request->input('keyword', '');
        $perPage = $request->input('per_page',PHP_INT_MAX);
        $sortBy = $request->input('sortBy', '');
        $sortType = $request->input('sortType', '');
        $dealership_id = $request->input('dealership', null);

        $data = EmployeeOffset::with([
            'recommending' => fn($recommending) => $recommending->select('employee_id', 'asa_user_id', 'firstname', 'lastname'),
            'approving'=> fn($approving) => $approving->select('employee_id', 'asa_user_id', 'firstname', 'lastname'),
            'employee'=> fn($employee) => $employee->select('employee_id', 'firstname', 'lastname'),
            ])
            ->select(
                'id', 
                'employee_id', 
                'company_id', 
                'dealer_id', 
                'date_from',
                'date_to',
                'from_time',
                'to_time',
                'days',
                'hours',
                'attachment', 
                'description', 
                'denied_reason', 
                'status', 
                'validated',
                'validated_by',
                'validated_at',
                'deferred_reason',
                'recommending_id', 
                'allow_higher_approval', 
                'approver_id', 
                'recommended_at', 
                'approved_at',
                'created_at',
                'posted'
            )
            ->where(function ($query) use ($keyword) {
            $keyword = str_replace(" ", "%", $keyword);
            // $query->where('name', 'like', '%' . $keyword . '%');
        });

        if($dealership_id) $data = $data->where('dealer_id', $dealership_id);

        if (!$request->date_created && !$request->range && !$request->status) {
            $data = $data->whereDate('created_at', '>=', now()->subDays(30));
        }
        
        if ($request->date_created) {
            $dates = explode(' to ', $request->date_created); // Split into start and end date
            if (count($dates) == 2) {
                $data = $data->whereBetween('created_at', [$dates[0], $dates[1]]);
            }
        }
        
        if ($request->range) {
            $dates = explode(' to ', $request->range); // Split into start and end date
            if (count($dates) == 2) {
                $data = $data->whereBetween('date_from', [$dates[0], $dates[1]]);
            }
        }
        
        if ($request->status && is_array($request->status)) {
            $data = $data->where(function ($query) use ($request) {
                if (in_array('pending', $request->status)) {
                    $query->orWhere('status', 0);
                }
        
                if (in_array('validated', $request->status)) {
                    $query->orWhere(function ($q) {
                        $q->where('status', 2)->where('validated', 1);
                    });
                }
        
                if (in_array('denied', $request->status)) {
                    $query->orWhere('status', 99)
                        ->orWhere(function ($q) {
                            $q->where('status', 2)->where('validated', 99);
                        });

                }
        
                if (in_array('for_validation', $request->status)) {
                    $query->orWhere(function ($q) {
                        $q->where('status', 2)->where('validated', 0);
                    });
                }
            });
        }
        
        $data = $data->paginate(500);

        $response = [
            'data' => $data,
        ];

        // dd($response);

        return response()->json($response);
    }

    public function store(Request $request)
    {
        $user = Auth::user();
        
        $validator = Validator::make($request->all(), [
            'date_from' => "required",
        ]);

        /** If validation fails return with error message */
        if ($validator->fails()) {
            $errors = $validator->errors();
            $first = $errors->getMessages();
            return response()->json([
                'status'  => false,
                'message' => (reset($first))[0],
                'errors'  => $errors
            ], Response::HTTP_UNPROCESSABLE_ENTITY);
        }

        DB::connection()->beginTransaction();

        try {
            $allow_higher_approval = ($request->allow_higher_approval && $request->allow_higher_approval !== 'null' && $request->allow_higher_approval !== 'false' && trim($request->allow_higher_approval) !== '' ? 1 : 0);
                
            $attachmentName = $this->handleAttachment($request);

            $Status = EmployeeOffset::create([
                'employee_id' => $user->employee_id,
                'company_id' => $user->employees->company_id,
                'dealer_id' => $user->employees->dealer_id,
                'date_from' => $request->date_from,
                'date_to' => $request->date_to,
                'from_time' => $request->from_time,
                'to_time' => $request->to_time,
                'hours' => $request->hours,
                'description' => $request->description,
                'attachment' => $attachmentName,
                'allow_higher_approval' => $allow_higher_approval,
                'recommending_id' => $request->recommending_id,
                'approver_id' => $request->approver_id,
                'status' => 0,
            ]);

            if(!OffsetRemaining::where('employee_id', '=', $Status->employee_id)->exists()){
                OffsetRemaining::create([
                    'employee_id' => $Status->employee_id,
                    'company_id' => $Status->company_id,
                    'remaining' => $request->hours
                ]);
            } else {
                $offset = OffsetRemaining::where('employee_id', '=', $Status->employee_id)->first();

                if ($offset) {
                    $offset->decrement('remaining', $request->hours);
                }
            }

            DB::connection()->commit();
            
            // Load the relationships
            $Status->load(['employee']);

            // $email_to = $this->getEmployeeEmailData($request->recommending_id);

            // Notification::send($email_to, new OffsetAvailment($Status));
            
            return response()->json([
                'status'  => true,
                'message' => 'Saved successfully!',
                'data'    => $Status
            ],201);

        } catch (Throwable $e) {

            DB::connection()->rollback();
            return response()->json([
                'status'  => false,
                'message' => 'Unable to process request. Please try again.',
                'data'    => $e->getMessage()
            ]);
        }
    }

    public function handleAttachment(Request $request)
    {
        if ($request->hasFile('attachment')) {
            $image = $request->file('attachment');
            $attachmentName = time() . '_' . $image->getClientOriginalName();
            $path = "employee-offset/" . $attachmentName;
            if (Storage::disk('local')->put($path, file_get_contents($image))) {
                return $attachmentName;
            }
            throw new Exception('Unable to process attachment.');
        }
        return '';
    }

    public function update(Request $request)
    {
        // dd($request->all());
        $id = $request->id;

        $data = EmployeeOffset::where('id', $id)->first();

        $user = Auth::user();
        
        $validator = Validator::make($request->all(), [
            'date' => "required|date",
        ]);

        /** If validation fails return with error message */
        if ($validator->fails()) {
            $errors = $validator->errors();
            $first = $errors->getMessages();
            return response()->json([
                'status'  => false,
                'message' => (reset($first))[0],
                'errors'  => $errors
            ], Response::HTTP_UNPROCESSABLE_ENTITY);
        }

        $attachment_name = $request->attachment;

        if($data->attachment != $request->attachment)
        {
            $attachment_file_path = 'employee-offset/' . $data->attachment;
            if(Storage::exists($attachment_file_path))
            {
                Storage::delete($attachment_file_path);
            }

            if($request->hasFile('attachment')) {
                $image      = $request->file('attachment');
                $attachment_name  = time().'_'.$image->getClientOriginalName();
                $path       = "employee-offset/".$attachment_name;
                if(!Storage::disk('local')->put($path, file_get_contents($image)))
                {
                    return response()->json(['message'=> "Failed to upload attachment"],304);
                }
            }
            else
            {
                $attachment_name = null;
            }
        }

        DB::connection()->beginTransaction();

        try {
            $allow_higher_approval = ($request->allow_higher_approval && $request->allow_higher_approval !== 'null' && $request->allow_higher_approval !== 'false' && trim($request->allow_higher_approval) !== '' ? 1 : 0);
            
            $data->employee_id = $user->employee_id;
            $data->date_from = $request->date_from;
            $data->date_to = $request->date_to;
            $data->from_time = $request->from_time;
            $data->to_time = $request->to_time;
            $data->hours = $request->hours;
            $data->description = $request->description;
            $data->allow_higher_approval = $allow_higher_approval;
            $data->attachment = $attachment_name;
            $data->save();
            
            DB::connection()->commit();

            return response()->json([
                'status'  => true,
                'message' => 'Saved successfully!',
                'data'    => $data
            ],201);

        } catch (Throwable $e) {

            DB::connection()->rollback();
            return response()->json([
                'status'  => false,
                'message' => 'Unable to process request. Please try again.',
                'data'    => $e->getMessage()
            ]);
        } 
    }

    public function destroy(int $id)
    {
        $data = EmployeeOffset::find($id);

        $offset = OffsetRemaining::where('employee_id', '=', $data->employee_id)->first();

        if ($offset) {
            $offset->increment('remaining', $data->hours);
        }
        
        if(!$data)
        {
            return response()->json(['message' => "Record not found!"],204);
        }
        DB::connection()->beginTransaction();
        $data->delete();
        DB::connection()->commit();
        return response()->json(['message' => "Record successfully deleted!"],201);
    }

    public function removeAttachment(Request $request)
    {
        $id = $request->id;
        $attachment = $request->attachment;

        $data = EmployeeOffset::where('id', $id)->first();

        $data->attachment = NULL;

        $data->save();

        DB::connection()->commit();
        
        $attachment_file_path = 'employee-offset/' . $request->attachment;
        if(Storage::exists($attachment_file_path))
        {
            Storage::delete($attachment_file_path);
        }

        return response()->json([
            'status'  => true,
            'message' => 'Saved successfully!',
            'data'    => $data
        ],201);
    }

    public function getEmployeeEmailData($id){
        return User::where('employee_id', '=', $id)->first();
    }
}
